
//Wolf, March.2007
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "R001.h"

HINSTANCE hInst;    //Instance handle
HWND hwndMain;      //Main window handle
HMENU hMenu;        //menu handle
HWND hWndStatusbar; //Status Bar handle
HWND hwndButton;    //Button handle
HWND hwndLabel;     //Static Control Handle
HWND hwndEdit;      //Edit Control Handle
int lang;           //code page
DWORD ret;
HFONT new_font1;    //Cyrillic Arial 10 Normal
HFONT new_font2;    //Arial for English on Russian machine
HFONT new_font3;    //Cyrillic Tahoma 12 Bold for edit, button control

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);


// lots of warnings  :)
// English title/menu strings
char e_wintitle[] = "Russian/English Menu Demo";
char e_menu00[] = "&File";
char e_menu01[] = "&New";
char e_menu02[] = "&Open";
char e_menu03[] = "&Save";
char e_menu04[] = "Save &As";
char e_menu05[] = "&Print";
char e_menu06[] = "E&xit";
char e_menu07[] = "E&dit";
char e_menu08[] = "&Clear";
char e_menu10[] = "&Language";
char e_menu11[] = "&English";
char e_menu20[] = "&Help";
char e_menu21[] = "&About";

// Russian title/menu strings
char r_wintitle[] = "- - ";
char r_menu00[] = "";
char r_menu01[] = "";
char r_menu02[] = "";
char r_menu03[] = "";
char r_menu04[] = " ";
char r_menu05[] = "";
char r_menu07[] = "";
char r_menu08[] = "";
char r_menu06[] = "";
char r_menu10[] = "";
char r_menu11[] = "";
char r_menu20[] = "";
char r_menu21[] = " ";


//--make language English
void ToEnglish(void)
{
  SetWindowText(hwndMain,&e_wintitle);
  ModifyMenu(hMenu,0,MF_BYPOSITION|MF_STRING,0,&e_menu00);
  ModifyMenu(hMenu,IDM_NEW,MF_BYCOMMAND|MF_STRING,IDM_NEW,&e_menu01);
  ModifyMenu(hMenu,IDM_OPEN,MF_BYCOMMAND|MF_STRING,IDM_OPEN,&e_menu02);
  ModifyMenu(hMenu,IDM_SAVE,MF_BYCOMMAND|MF_STRING,IDM_SAVE,&e_menu03);
  ModifyMenu(hMenu,IDM_SAVEAS,MF_BYCOMMAND|MF_STRING,IDM_SAVEAS,&e_menu04);
  ModifyMenu(hMenu,IDM_PRINT,MF_BYCOMMAND|MF_STRING,IDM_PRINT,&e_menu05);
  ModifyMenu(hMenu,IDM_EXIT,MF_BYCOMMAND|MF_STRING,IDM_EXIT,&e_menu06);

  ModifyMenu(hMenu,1,MF_BYPOSITION|MF_STRING,1,&e_menu07);
  ModifyMenu(hMenu,IDM_CLEAR,MF_BYCOMMAND|MF_STRING,IDM_CLEAR,&e_menu08);

  ModifyMenu(hMenu,2,MF_BYPOSITION|MF_STRING,2,&e_menu10);
  ModifyMenu(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_STRING|MF_GRAYED,IDM_ENGLISH,&e_menu11);
  ModifyMenu(hMenu,3,MF_BYPOSITION|MF_STRING,3,&e_menu20);
  ModifyMenu(hMenu,IDM_ABOUT,MF_BYCOMMAND|MF_STRING,IDM_ABOUT,&e_menu21);
  DrawMenuBar(hwndMain);	//update all
  SetWindowText(hwndButton,"Exit");
  SendMessage(hWndStatusbar,WM_SETFONT,(WPARAM)new_font2,1);
}

//--make language Russian
void ToRussian(void)
{
  SetWindowText(hwndMain,&r_wintitle);
  ModifyMenu(hMenu,0,MF_BYPOSITION|MF_STRING,0,&r_menu00);
  ModifyMenu(hMenu,IDM_NEW,MF_BYCOMMAND|MF_STRING,IDM_NEW,&r_menu01);
  ModifyMenu(hMenu,IDM_OPEN,MF_BYCOMMAND|MF_STRING,IDM_OPEN,&r_menu02);
  ModifyMenu(hMenu,IDM_SAVE,MF_BYCOMMAND|MF_STRING,IDM_SAVE,&r_menu03);
  ModifyMenu(hMenu,IDM_SAVEAS,MF_BYCOMMAND|MF_STRING,IDM_SAVEAS,&r_menu04);
  ModifyMenu(hMenu,IDM_PRINT,MF_BYCOMMAND|MF_STRING,IDM_PRINT,&r_menu05);
  ModifyMenu(hMenu,IDM_EXIT,MF_BYCOMMAND|MF_STRING,IDM_EXIT,&r_menu06);

  ModifyMenu(hMenu,1,MF_BYPOSITION|MF_STRING,1,&r_menu07);
  ModifyMenu(hMenu,IDM_CLEAR,MF_BYCOMMAND|MF_STRING,IDM_CLEAR,&r_menu08);

  ModifyMenu(hMenu,2,MF_BYPOSITION|MF_STRING,2,&r_menu10);
  ModifyMenu(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_STRING,IDM_ENGLISH,&r_menu11);
  ModifyMenu(hMenu,3,MF_BYPOSITION|MF_STRING,3,&r_menu20);
  ModifyMenu(hMenu,IDM_ABOUT,MF_BYCOMMAND|MF_STRING,IDM_ABOUT,&r_menu21);
  DrawMenuBar(hwndMain);	//update all
  SetWindowText(hwndButton,"");
  SendMessage(hWndStatusbar,WM_SETFONT,(WPARAM)new_font1,1);
}


//--sends message to status bar
void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags)
{
  SendMessage(hWndStatusbar,SB_SETTEXT,
    partNumber|displayFlags,(LPARAM)lpszStatusString);
}

//--
static BOOL CreateSBar(HWND hwndParent,char *initialText)
{
  hWndStatusbar = CreateStatusWindow(WS_CHILD|WS_VISIBLE|WS_BORDER,
    initialText,
    hwndParent,
    IDM_STATUSBAR);

  if(hWndStatusbar)
  {
    // increase size of status bar
    SendMessage(hWndStatusbar,SB_SETMINHEIGHT,20,0);
    SendMessage(hWndStatusbar,WM_SIZE,0,0);
    return TRUE;
  }
  return FALSE;
}

//--selects message for status bar
LRESULT MsgMenuSelect( WPARAM wparam, LPARAM lparam )
{
  static char szBuffer[256];
  UINT   nStringID = 0;
  UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
  UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
  HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

  szBuffer[0] = 0;                          // Reset buffer

  if (fuFlags == 0xffff && hMenu == NULL)   // Menu closed
    nStringID = 0;
  else if (fuFlags & MFT_SEPARATOR)         // Ignore separators
    nStringID = 0;
  else if (fuFlags & MF_POPUP)              // Popup messages
    {
    if (uCmd==0)
      nStringID = ID_FILEMENU;

    //note: position 1 skipped

    else if (uCmd==2)
      nStringID = ID_LANGMENU;
    else if (uCmd==3)
      nStringID = ID_HELPMENU;
    }
  else                                      // is a command item
    nStringID = uCmd;

    // Load the string if we have an ID, Russian offset by 100
    if (0 != nStringID)
      if (lang==1251)
        LoadString(hInst, nStringID+100, szBuffer, sizeof(szBuffer));
      else
        LoadString(hInst, nStringID, szBuffer, sizeof(szBuffer));

    // Send the string to the status bar
    UpdateStatusBar(szBuffer, 0, 0);
  return 0;
}


//--
static BOOL InitApplication(void)
{
 WNDCLASS wc;

 memset(&wc,0,sizeof(WNDCLASS));
 wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
 wc.lpfnWndProc = (WNDPROC)MainWndProc;
 wc.hInstance = hInst;
 wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
 wc.lpszClassName = "demoClass";
 wc.lpszMenuName = MAKEINTRESOURCE(MAINMENU);
 wc.hCursor = LoadCursor(NULL,IDC_ARROW);
 wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDAPPLICON));
 if (!RegisterClass(&wc))
  return 0;

 InitCommonControls();	// just in case
 lang = GetACP();		// is Russian ??
  return 1;
}

//--main window
HWND CreateDemoWnd(void)
{
 return CreateWindow("demoClass"," ",
  WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
  CW_USEDEFAULT,CW_USEDEFAULT,638,250,
  NULL,
  NULL,
  hInst,
  NULL);
}

//--
int _stdcall AboutDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
	case WM_CLOSE:
		EndDialog(hwnd,0);
		return 1;
	case WM_COMMAND:
	switch (LOWORD(wParam)) {
	case ID_OK:
		EndDialog(hwnd,1);
		return 1;
		}
		break;
	}
	return 0;
}


//--
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
RECT rect;

	switch (msg) {
	case WM_CREATE:
		hwndLabel=CreateWindow("static","- edit control, Cyrillic Tahoma 12 Bold font, lf.lfHeight = 19, lf.lfWeight = 700",
		WS_CHILD|WS_VISIBLE|SS_RIGHT,
		2,6,624,20,
		hwnd,
		0,
		hInst,
		NULL);

		hwndEdit=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",
		WS_CHILD|WS_VISIBLE|WS_BORDER,
		2,34,628,28,
		hwnd,
		0,
		hInst,
		NULL);

		GetClientRect(hwnd,&rect);	//for button 'y' location

		hwndButton=CreateWindow("button","Exit",
		WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|WS_TABSTOP,
		10,rect.bottom - 66,100,29,
		hwnd,
		MAKEINTRESOURCE(IDM_EXIT),
		hInst,
		NULL);
		SetFocus(hwndButton);
		break;
	case WM_MENUSELECT:
		return MsgMenuSelect( wParam, lParam );
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
   	case IDM_CLEAR:
		SetWindowText(hwndEdit,"");
		break;		

	case IDM_ABOUT:
		if (lang==1251)
			DialogBox(hInst,MAKEINTRESOURCE(IDD_RABOUT),
				hwndMain,AboutDlg);
		else
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),
				hwndMain,AboutDlg);
		SetFocus(hwndButton);
		break;

	case IDM_ENGLISH:
		if (lang==1251)
		{
		ret=CheckMenuItem(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_CHECKED);
		lang = 1252;
		ToEnglish();
		ModifyMenu(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_STRING|MF_CHECKED,IDM_ENGLISH,&e_menu11);
		}
		else
		{
		ret=CheckMenuItem(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_UNCHECKED);
		lang = 1251;
		ToRussian();
		ModifyMenu(hMenu,IDM_ENGLISH,MF_BYCOMMAND|MF_STRING|MF_UNCHECKED,IDM_ENGLISH,&r_menu11);
		}
		break;

	case IDM_EXIT:
		PostMessage(hwnd,WM_CLOSE,0,0);
		break;
	}
    break;
	case WM_DESTROY:
		DeleteObject(new_font1);
		DeleteObject(new_font2);
		DeleteObject(new_font3);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}


//--
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	LOGFONT lf;

	hInst = hInstance;
	if (!InitApplication())
		return 0;
	if ((hwndMain = CreateDemoWnd()) == (HWND)0)
		return 0;

	hMenu = GetMenu(hwndMain);
	if (lang==1251)
{
		ToRussian();

	CreateSBar(hwndMain,"");
	memset(&lf,0,sizeof(LOGFONT));
	lf.lfHeight = 16;
	lf.lfWeight = 500;	// normal weight

}
	else
{
		ToEnglish();	// if not Russian, make menu strings, etc, English


	CreateSBar(hwndMain,"Ready");

	// create and set larger font for status bar

	memset(&lf,0,sizeof(LOGFONT));
	lf.lfHeight = 16;
	lf.lfWeight = 500;	// normal weight
}
	if (lang==1251)
		{
		lf.lfCharSet = RUSSIAN_CHARSET;
		strcpy(lf.lfFaceName, "Arial");
		new_font1=CreateFontIndirect(&lf);
        SendMessage(hWndStatusbar,WM_SETFONT,(WPARAM)new_font1,1);

		lf.lfCharSet = ANSI_CHARSET;	//also, for English on Russian machine
		strcpy(lf.lfFaceName, "Arial");
		new_font2=CreateFontIndirect(&lf);
		}
	else
		{
		lf.lfCharSet = ANSI_CHARSET;	//for English elsewhere
		strcpy(lf.lfFaceName, "Arial");
		new_font2=CreateFontIndirect(&lf);
		SendMessage(hWndStatusbar,WM_SETFONT,(WPARAM)new_font2,1);
		}

	//create larger BOLD Tahoma font for edit, button controls
	memset(&lf,0,sizeof(LOGFONT));
	lf.lfHeight = 19;
	lf.lfWeight = 700;	// bold
	lf.lfCharSet = RUSSIAN_CHARSET;
	strcpy(lf.lfFaceName, "Tahoma");
	new_font3=CreateFontIndirect(&lf);
	SendMessage(hwndEdit,WM_SETFONT,(WPARAM)new_font3,1);

	//RUSSIAN_CHARSET has English ANSI below 0x7F, so..
	// * bad example, assumes *everyone* has RUSSIAN_CHARSET, ??
	// or is font substitution automatic anyways ??
	SendMessage(hwndButton,WM_SETFONT,(WPARAM)new_font3,1);

	ShowWindow(hwndMain,SW_SHOW);
	while (GetMessage(&msg,NULL,0,0)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
	}
	return msg.wParam;
}
